Index: /branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShapeInfo.cs
===================================================================
--- /branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShapeInfo.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShapeInfo.cs	(revision 6046)
@@ -22,14 +22,17 @@
 using System.Collections.Generic;
 using System.Drawing;
-using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using Netron.Diagramming.Core;
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
   [StorableClass]
-  internal class OperatorShapeInfo : ShapeInfo, IOperatorShapeInfo {
+  public class OperatorShapeInfo : ShapeInfo, IOperatorShapeInfo {
     [Storable]
     private List<string> labels;
+    public IEnumerable<string> Labels {
+      get { return labels; }
+    }
+
+    private object lockObject = new object();
 
     [StorableConstructor]
@@ -42,5 +45,12 @@
       lineWidth = original.lineWidth;
       title = original.title;
-      if (original.icon != null) icon = (Bitmap)original.icon.Clone();
+
+      //mkommend: necessary because cloning a Bitmap is not threadsafe
+      //see http://stackoverflow.com/questions/1851292/invalidoperationexception-object-is-currently-in-use-elsewhere for further information
+      if (original.icon != null) {
+        lock (original.lockObject) {
+          icon = (Bitmap)original.icon.Clone();
+        }
+      }
 
       connectorNames = new List<string>(original.connectorNames);
@@ -52,5 +62,5 @@
 
     public OperatorShapeInfo()
-      : base(typeof(OperatorShape)) {
+      : base() {
       this.connectorNames = new List<string>();
       this.labels = new List<string>();
@@ -164,74 +174,4 @@
       }
     }
-
-    public override IShape CreateShape() {
-      OperatorShape shape = (OperatorShape)base.CreateShape();
-      shape.Title = this.Title;
-      shape.Color = this.Color;
-      shape.LineColor = this.LineColor;
-      shape.LineWidth = this.LineWidth;
-      shape.Icon = this.Icon;
-      shape.Collapsed = this.Collapsed;
-      foreach (string connectorName in this.connectorNames)
-        if (connectorName != OperatorShapeInfoFactory.SuccessorConnector && connectorName != OperatorShapeInfoFactory.PredecessorConnector)
-          shape.AddConnector(connectorName);
-
-      shape.UpdateLabels(this.labels);
-      return shape;
-    }
-
-    public override void UpdateShape(IShape shape) {
-      base.UpdateShape(shape);
-      OperatorShape operatorShape = (OperatorShape)shape;
-      operatorShape.Title = this.Title;
-      operatorShape.Color = this.Color;
-      operatorShape.LineColor = this.LineColor;
-      operatorShape.LineWidth = this.LineWidth;
-      operatorShape.Icon = this.Icon;
-      operatorShape.Collapsed = this.Collapsed;
-
-      int i = 0;
-      int j = 0;
-      //remove old connectors and skip correct connectors
-      List<string> oldConnectorNames = operatorShape.AdditionalConnectorNames.ToList();
-      while (i < this.connectorNames.Count && j < oldConnectorNames.Count) {
-        if (connectorNames[i] == OperatorShapeInfoFactory.SuccessorConnector ||
-          connectorNames[i] == OperatorShapeInfoFactory.PredecessorConnector)
-          i++;
-        else if (oldConnectorNames[j] == OperatorShapeInfoFactory.SuccessorConnector ||
-          oldConnectorNames[j] == OperatorShapeInfoFactory.PredecessorConnector)
-          j++;
-        else if (this.connectorNames[i] != oldConnectorNames[j]) {
-          operatorShape.RemoveConnector(oldConnectorNames[j]);
-          j++;
-        } else {
-          i++;
-          j++;
-        }
-      }
-      //remove remaining old connectors
-      for (; j < oldConnectorNames.Count; j++)
-        operatorShape.RemoveConnector(oldConnectorNames[j]);
-
-      //add new connectors except successor and connector
-      for (; i < this.connectorNames.Count; i++)
-        if (this.connectorNames[i] != OperatorShapeInfoFactory.SuccessorConnector && this.connectorNames[i] != OperatorShapeInfoFactory.PredecessorConnector)
-          operatorShape.AddConnector(this.connectorNames[i]);
-
-      operatorShape.UpdateLabels(this.labels);
-    }
-
-    public override void UpdateShapeInfo(IShape shape) {
-      base.UpdateShapeInfo(shape);
-      OperatorShape operatorShape = (OperatorShape)shape;
-      this.Title = operatorShape.Title;
-      this.Color = operatorShape.Color;
-      this.LineColor = operatorShape.LineColor;
-      this.LineWidth = operatorShape.LineWidth;
-      this.Icon = operatorShape.Icon;
-      this.Collapsed = operatorShape.Collapsed;
-
-      //TODO update Connector and labels;
-    }
   }
 }
Index: /branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShapeInfoFactory.cs
===================================================================
--- /branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShapeInfoFactory.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShapeInfoFactory.cs	(revision 6046)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
-  internal static class OperatorShapeInfoFactory {
+  public static class OperatorShapeInfoFactory {
     public const string PredecessorConnector = "Predecessor";
     public const string SuccessorConnector = "Successor";
Index: /branches/histogram/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj
===================================================================
--- /branches/histogram/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj	(revision 6045)
+++ /branches/histogram/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj	(revision 6046)
@@ -96,12 +96,4 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.Common.Resources-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
-    <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
-    <Reference Include="HeuristicLab.Data.Views-3.3">
-      <HintPath>..\..\HeuristicLab.Data.Views\3.3\bin\Debug\HeuristicLab.Data.Views-3.3.dll</HintPath>
-    </Reference>
-    <Reference Include="HeuristicLab.Optimization-3.3">
-      <HintPath>..\..\HeuristicLab.Optimization\3.3\bin\Debug\HeuristicLab.Optimization-3.3.dll</HintPath>
-    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -164,4 +156,8 @@
       <Name>HeuristicLab.Collections-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.3\HeuristicLab.Common.Resources-3.3.csproj">
+      <Project>{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}</Project>
+      <Name>HeuristicLab.Common.Resources-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
       <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
@@ -176,4 +172,12 @@
       <Name>HeuristicLab.Core-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Data.Views\3.3\HeuristicLab.Data.Views-3.3.csproj">
+      <Project>{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}</Project>
+      <Name>HeuristicLab.Data.Views-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj">
+      <Project>{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}</Project>
+      <Name>HeuristicLab.Data-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj">
       <Project>{AB687BBE-1BFE-476B-906D-44237135431D}</Project>
@@ -191,4 +195,8 @@
       <Project>{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}</Project>
       <Name>HeuristicLab.Optimization.Views-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
Index: /branches/histogram/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj
===================================================================
--- /branches/histogram/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj	(revision 6045)
+++ /branches/histogram/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj	(revision 6046)
@@ -19,5 +19,6 @@
     </UpgradeBackupLocation>
     <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
-    <TargetFrameworkProfile></TargetFrameworkProfile>
+    <TargetFrameworkProfile>
+    </TargetFrameworkProfile>
     <PublishUrl>publish\</PublishUrl>
     <Install>true</Install>
@@ -109,4 +110,5 @@
     <Compile Include="MultiObjective\FastNonDominatedSort.cs" />
     <Compile Include="MultiObjective\RankAndCrowdingSorter.cs" />
+    <Compile Include="ShakingOperator.cs" />
     <Compile Include="UserDefinedCrossover.cs" />
     <Compile Include="UserDefinedEvaluator.cs" />
Index: /branches/histogram/HeuristicLab.Optimization.Operators/3.3/QualityComparator.cs
===================================================================
--- /branches/histogram/HeuristicLab.Optimization.Operators/3.3/QualityComparator.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Optimization.Operators/3.3/QualityComparator.cs	(revision 6046)
@@ -51,5 +51,5 @@
       Parameters.Add(new LookupParameter<DoubleValue>("LeftSide", "The left side of the comparison."));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("RightSide", "The right side of the comparison."));
-      Parameters.Add(new LookupParameter<BoolValue>("Result", "The result of the comparison."));
+      Parameters.Add(new LookupParameter<BoolValue>("Result", "The result of the comparison, true if the quality on the LeftSide is better than the quality on the RightSide."));
       Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization", "True if the problem is a maximization problem, otherwise false."));
     }
Index: /branches/histogram/HeuristicLab.Optimization.Operators/3.3/ShakingOperator.cs
===================================================================
--- /branches/histogram/HeuristicLab.Optimization.Operators/3.3/ShakingOperator.cs	(revision 6046)
+++ /branches/histogram/HeuristicLab.Optimization.Operators/3.3/ShakingOperator.cs	(revision 6046)
@@ -0,0 +1,73 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators {
+  /// <summary>
+  /// A shaking operator for VNS.
+  /// </summary>
+  [Item("ShakingOperator", "A shaking operator for VNS that can be filled with arbitrary manipulation operators.")]
+  [StorableClass]
+  public class ShakingOperator<T> : CheckedMultiOperator<T>, IMultiNeighborhoodShakingOperator where T : class, IManipulator {
+
+    public IValueLookupParameter<IntValue> CurrentNeighborhoodIndexParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["CurrentNeighborhoodIndex"]; }
+    }
+
+    public ILookupParameter<IntValue> NeighborhoodCountParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["NeighborhoodCount"]; }
+    }
+
+    [StorableConstructor]
+    protected ShakingOperator(bool deserializing) : base(deserializing) { }
+    protected ShakingOperator(ShakingOperator<T> original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ShakingOperator<T>(this, cloner);
+    }
+    public ShakingOperator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<IntValue>("CurrentNeighborhoodIndex", "The index of the operator that should be applied (k)."));
+      Parameters.Add(new LookupParameter<IntValue>("NeighborhoodCount", "The number of operators that are available."));
+    }
+
+    public override IOperation Apply() {
+      if (NeighborhoodCountParameter.ActualValue == null)
+        NeighborhoodCountParameter.ActualValue = new IntValue(Operators.CheckedItems.Count());
+      else NeighborhoodCountParameter.ActualValue.Value = Operators.CheckedItems.Count();
+
+      int index = CurrentNeighborhoodIndexParameter.ActualValue.Value;
+      var shaker = base.Operators.CheckedItems.SingleOrDefault(x => x.Index == index);
+
+      OperationCollection next = new OperationCollection(base.Apply());
+      if (shaker.Value != null)
+        next.Insert(0, ExecutionContext.CreateChildOperation(shaker.Value));
+
+      return next;
+    }
+  }
+}
Index: /branches/histogram/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.Designer.cs
===================================================================
--- /branches/histogram/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.Designer.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.Designer.cs	(revision 6046)
@@ -204,5 +204,5 @@
       this.chart.Text = "chart";
       this.chart.AxisViewChanged += new System.EventHandler<System.Windows.Forms.DataVisualization.Charting.ViewEventArgs>(this.chart_AxisViewChanged);
-      this.chart.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(this.chart_DoubleClick);
+      this.chart.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDoubleClick);
       this.chart.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove);
       this.chart.MouseUp += new System.Windows.Forms.MouseEventHandler(this.chart_MouseUp);
Index: /branches/histogram/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs
===================================================================
--- /branches/histogram/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs	(revision 6046)
@@ -432,5 +432,5 @@
 
     #region Drag & drop and tooltip
-    private void chart_DoubleClick(object sender, MouseEventArgs e) {
+    private void chart_MouseDoubleClick(object sender, MouseEventArgs e) {
       HitTestResult h = this.chart.HitTest(e.X, e.Y);
       if (h.ChartElementType == ChartElementType.DataPoint) {
@@ -441,6 +441,7 @@
           view.Locked = this.Locked;
         }
-        this.chart.ChartAreas[0].CursorX.SetSelectionPosition(double.NaN, double.NaN);
-        this.chart.ChartAreas[0].CursorY.SetSelectionPosition(double.NaN, double.NaN);
+
+        this.chart.ChartAreas[0].CursorX.SelectionStart = this.chart.ChartAreas[0].CursorX.SelectionEnd;
+        this.chart.ChartAreas[0].CursorY.SelectionStart = this.chart.ChartAreas[0].CursorY.SelectionEnd;
       }
     }
Index: /branches/histogram/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- /branches/histogram/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 6045)
+++ /branches/histogram/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 6046)
@@ -120,4 +120,6 @@
     <Compile Include="Interfaces\ILocalParticleUpdater.cs" />
     <Compile Include="Algorithms\HeuristicOptimizationAlgorithm.cs" />
+    <Compile Include="Interfaces\IMultiNeighborhoodShakingOperator.cs" />
+    <Compile Include="MoveHelper.cs" />
     <Compile Include="Problems\MultiObjectiveHeuristicOptimizationProblem.cs" />
     <Compile Include="Problems\HeuristicOptimizationProblem.cs" />
Index: /branches/histogram/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementOperator.cs
===================================================================
--- /branches/histogram/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementOperator.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementOperator.cs	(revision 6046)
@@ -21,13 +21,14 @@
 
 using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
 using HeuristicLab.Core;
-using HeuristicLab.Optimization;
+using HeuristicLab.Data;
 
 namespace HeuristicLab.Optimization {
-  public interface ILocalImprovementOperator: IOperator {
-    void OnProblemChanged(IProblem problem);
+  public interface ILocalImprovementOperator : IOperator {
+    Type ProblemType { get; }
+    IProblem Problem { get; set; }
+    IValueLookupParameter<IntValue> MaximumIterationsParameter { get; }
+    ILookupParameter<IntValue> EvaluatedSolutionsParameter { get; }
+    ILookupParameter<ResultCollection> ResultsParameter { get; }
   }
 }
Index: /branches/histogram/HeuristicLab.Optimization/3.3/Interfaces/IMultiNeighborhoodShakingOperator.cs
===================================================================
--- /branches/histogram/HeuristicLab.Optimization/3.3/Interfaces/IMultiNeighborhoodShakingOperator.cs	(revision 6046)
+++ /branches/histogram/HeuristicLab.Optimization/3.3/Interfaces/IMultiNeighborhoodShakingOperator.cs	(revision 6046)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Optimization {
+  public interface IMultiNeighborhoodShakingOperator : IOperator {
+    IValueLookupParameter<IntValue> CurrentNeighborhoodIndexParameter { get; }
+    ILookupParameter<IntValue> NeighborhoodCountParameter { get; }
+  }
+}
Index: /branches/histogram/HeuristicLab.Optimization/3.3/MoveHelper.cs
===================================================================
--- /branches/histogram/HeuristicLab.Optimization/3.3/MoveHelper.cs	(revision 6046)
+++ /branches/histogram/HeuristicLab.Optimization/3.3/MoveHelper.cs	(revision 6046)
@@ -0,0 +1,66 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimization {
+  /// <summary>
+  /// This class provides some methods useful when dealing with moves, such as getting compatible move makers to a move generator.
+  /// Compatibility is generally ensured in that both the generator and the move maker implement the same specific interface which is derived from IMoveOperator
+  /// </summary>
+  public static class MoveHelper {
+
+    public static IEnumerable<IMoveMaker> GetCompatibleMoveMakers(IMoveGenerator generator, IEnumerable<IOperator> operators) {
+      return GetCompatibleOperators<IMoveMaker>(generator, operators);
+    }
+
+    public static IEnumerable<ISingleObjectiveMoveEvaluator> GetCompatibleSingleObjectiveMoveEvaluators(IMoveGenerator generator, IEnumerable<IOperator> operators) {
+      return GetCompatibleOperators<ISingleObjectiveMoveEvaluator>(generator, operators);
+    }
+
+    public static IEnumerable<ITabuChecker> GetCompatibleTabuChekers(IMoveGenerator generator, IEnumerable<IOperator> operators) {
+      return GetCompatibleOperators<ITabuChecker>(generator, operators);
+    }
+
+    public static IEnumerable<ITabuMaker> GetCompatibleTabuMakers(IMoveGenerator generator, IEnumerable<IOperator> operators) {
+      return GetCompatibleOperators<ITabuMaker>(generator, operators);
+    }
+
+    private static IEnumerable<T> GetCompatibleOperators<T>(IMoveGenerator generator, IEnumerable<IOperator> operators) where T : IOperator {
+      foreach (Type type in GetMostSpecificMoveOperatorTypes(generator)) {
+        foreach (T op in operators.Where(x => type.IsAssignableFrom(x.GetType())).OfType<T>())
+          yield return op;
+      }
+    }
+
+    private static List<Type> GetMostSpecificMoveOperatorTypes(IMoveGenerator generator) {
+      List<Type> moveTypes = generator.GetType().GetInterfaces().Where(x => typeof(IMoveOperator).IsAssignableFrom(x)).ToList();
+      foreach (Type type in moveTypes.ToList()) {
+        if (moveTypes.Any(t => t != type && type.IsAssignableFrom(t)))
+          moveTypes.Remove(type);
+      }
+      return moveTypes;
+    }
+  }
+}
Index: /branches/histogram/HeuristicLab.Problems.Knapsack/3.3/KnapsackProblem.cs
===================================================================
--- /branches/histogram/HeuristicLab.Problems.Knapsack/3.3/KnapsackProblem.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Problems.Knapsack/3.3/KnapsackProblem.cs	(revision 6046)
@@ -339,4 +339,6 @@
         op.ValuesParameter.ActualName = ValuesParameter.Name;
       }
+      foreach (var op in Operators.OfType<IBinaryVectorMultiNeighborhoodShakingOperator>())
+        op.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
     }
     #endregion
Index: /branches/histogram/HeuristicLab.Problems.OneMax/3.3/OnemaxProblem.cs
===================================================================
--- /branches/histogram/HeuristicLab.Problems.OneMax/3.3/OnemaxProblem.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Problems.OneMax/3.3/OnemaxProblem.cs	(revision 6046)
@@ -262,4 +262,6 @@
         op.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
       }
+      foreach (var op in Operators.OfType<IBinaryVectorMultiNeighborhoodShakingOperator>())
+        op.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
     }
     #endregion
Index: /branches/histogram/HeuristicLab.Problems.QuadraticAssignment/3.3/QuadraticAssignmentProblem.cs
===================================================================
--- /branches/histogram/HeuristicLab.Problems.QuadraticAssignment/3.3/QuadraticAssignmentProblem.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Problems.QuadraticAssignment/3.3/QuadraticAssignmentProblem.cs	(revision 6046)
@@ -312,4 +312,6 @@
         }
       }
+      foreach (var op in Operators.OfType<IPermutationMultiNeighborhoodShakingOperator>())
+        op.PermutationParameter.ActualName = SolutionCreator.PermutationParameter.ActualName;
     }
 
Index: /branches/histogram/HeuristicLab.Problems.TestFunctions/3.3/SingleObjectiveTestFunctionProblem.cs
===================================================================
--- /branches/histogram/HeuristicLab.Problems.TestFunctions/3.3/SingleObjectiveTestFunctionProblem.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Problems.TestFunctions/3.3/SingleObjectiveTestFunctionProblem.cs	(revision 6046)
@@ -417,4 +417,6 @@
         op.MaximizationParameter.ActualName = MaximizationParameter.Name;
       }
+      foreach (var op in Operators.OfType<IRealVectorMultiNeighborhoodShakingOperator>())
+        op.RealVectorParameter.ActualName = SolutionCreator.RealVectorParameter.ActualName;
     }
     private void UpdateStrategyVectorBounds() {
Index: /branches/histogram/HeuristicLab.Problems.TravelingSalesman/3.3/TravelingSalesmanProblem.cs
===================================================================
--- /branches/histogram/HeuristicLab.Problems.TravelingSalesman/3.3/TravelingSalesmanProblem.cs	(revision 6045)
+++ /branches/histogram/HeuristicLab.Problems.TravelingSalesman/3.3/TravelingSalesmanProblem.cs	(revision 6046)
@@ -389,4 +389,6 @@
       foreach (IPermutationTranslocationMoveOperator op in Operators.OfType<IPermutationTranslocationMoveOperator>())
         op.TranslocationMoveParameter.ActualName = translocationMove;
+      foreach (IPermutationMultiNeighborhoodShakingOperator op in Operators.OfType<IPermutationMultiNeighborhoodShakingOperator>())
+        op.PermutationParameter.ActualName = SolutionCreator.PermutationParameter.ActualName;
     }
 
Index: /branches/histogram/HeuristicLab.Problems.VehicleRouting/3.3/HeuristicLab.Problems.VehicleRouting-3.3.csproj
===================================================================
--- /branches/histogram/HeuristicLab.Problems.VehicleRouting/3.3/HeuristicLab.Problems.VehicleRouting-3.3.csproj	(revision 6045)
+++ /branches/histogram/HeuristicLab.Problems.VehicleRouting/3.3/HeuristicLab.Problems.VehicleRouting-3.3.csproj	(revision 6046)
@@ -19,5 +19,6 @@
     </UpgradeBackupLocation>
     <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
-    <TargetFrameworkProfile></TargetFrameworkProfile>
+    <TargetFrameworkProfile>
+    </TargetFrameworkProfile>
     <PublishUrl>publish\</PublishUrl>
     <Install>true</Install>
@@ -111,4 +112,6 @@
     <Compile Include="Analyzers\BestVRPToursMemorizer.cs" />
     <Compile Include="Analyzers\BestVRPSolutionAnalyzer.cs" />
+    <Compile Include="Interfaces\IVRPMultiNeighborhoodShakingOperator.cs" />
+    <Compile Include="ShakingOperators\VehicleRoutingShakingOperator.cs" />
     <Compile Include="SolutionParser.cs" />
     <Compile Include="Encodings\Alba\Crossovers\AlbaPermutationCrossover.cs" />
Index: /branches/histogram/HeuristicLab.Problems.VehicleRouting/3.3/Interfaces/IVRPMultiNeighborhoodShakingOperator.cs
===================================================================
--- /branches/histogram/HeuristicLab.Problems.VehicleRouting/3.3/Interfaces/IVRPMultiNeighborhoodShakingOperator.cs	(revision 6046)
+++ /branches/histogram/HeuristicLab.Problems.VehicleRouting/3.3/Interfaces/IVRPMultiNeighborhoodShakingOperator.cs	(revision 6046)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.VehicleRouting {
+  public interface IVRPMultiNeighborhoodShakingOperator : IMultiNeighborhoodShakingOperator, IVRPOperator {
+    ILookupParameter<IVRPEncoding> VRPToursParameter { get; }
+  }
+}
